
#include "defines.h"

void initbootuart() {
  // set baud rate
  UBRRH = (unsigned char) (BRREG_VALUE>>8);                  
  UBRRL = (unsigned char) BRREG_VALUE;
  
  // enable receive and transmit
  UART_CONTROL_REG = (1 << RXEN) | (1 << TXEN);  
  
}


void sendchar(char c) {
  // prepare transmission
  UART_DATA_REG = c;  
  
  // wait until byte sendt                                 
  while (!(UART_STATUS_REG & (1 << TRANSMIT_COMPLETE_BIT)));
  
  // clear TXCflag
  UART_STATUS_REG |= (1 << TRANSMIT_COMPLETE_BIT);          
}


char recchar(void) {
  // wait for data
  while(!(UART_STATUS_REG & (1 << RECEIVE_COMPLETE_BIT)));  
  
  return UART_DATA_REG;  
}



