
#include "defines.h"

void initbootuart() {
  // set baud rate
  UBRRH = (unsigned char) (BRREG_VALUE>>8);                  
  UBRRL = (unsigned char) BRREG_VALUE;
  
  // enable receive and transmit
  UART_CONTROL_REG = (1 << RXEN) | (1 << TXEN);  
  
}


void sendchar(char c) {
  // prepare transmission
  UART_DATA_REG = c;  
  
  // wait until byte sendt                                 
  while (!(UART_STATUS_REG & (1 << TRANSMIT_COMPLETE_BIT)));
  
  // clear TXCflag
  UART_STATUS_REG |= (1 << TRANSMIT_COMPLETE_BIT);          
}


char recchar(void) {
  // wait for data
  while(!(UART_STATUS_REG & (1 << RECEIVE_COMPLETE_BIT)));  
  
  return UART_DATA_REG;  
}

#define toupper(a) ((((a)>'a')*((a)<'z'))?((a)-('a'-'A')):(a))

unsigned char getnibble( void ) {
  char temp;
  temp = recchar();
  if ((temp = toupper(temp)) > '9') {
    return ((temp - 7) & 0x000F);
  } else {
    return (temp & 0x000F);
  }  
}

unsigned char getbyte( void ) {
  return (getnibble() << 4)|getnibble();
}

unsigned int getword( void ) {
 return (getbyte() << 8)|getbyte();
}

void printnibble( char data ) {
  char temp;
  if ((temp = data & 0x0F) > 9) {
     sendchar(temp + '7');
  } else {
     sendchar(temp + '0');
  }
}

void printbyte( char data ) {
  printnibble(data >>4);
  printnibble(data);
}

void printword( int data ) {
  printbyte(data >>8);
  printbyte(data);
}

void printbinary( char data ) {

}


